package org.kropp.examples;

import net.sf.xanswer.indexing.IndexException;

import org.kropp.index.Index;
import org.kropp.util.xml.XMLIndexFactory;

/**
 * Example of creating index structures for given xml.
 * 
 * @author Victor Kropp
 */
public class CreateIndex {
	/**
	 * Creates index structure for xml file passed as argument
	 * 
	 * @param args
	 *            Command-line arguments
	 */
	public static void main(String[] args) {
		if (args.length != 1) {
			System.err.println("Usage: java "
					+ new CurrentClassGetter().getName() + " <XML file>");
			System.exit(1);
		}

		try {
			Index index = XMLIndexFactory.getInstance().createIndex(args[0]);

			/*
			 * To save changes on disk flush() or close() must be called.
			 */
			index.close();
		} catch (IndexException ie) {
			System.err.println("Some error occured.");
			ie.printStackTrace();
		}
	}

	private static class CurrentClassGetter extends SecurityManager {
		public String getName() {
			return getClassContext()[1].getName();
		}
	}
}
