package org.kropp.index;

import java.util.Stack;
import org.kropp.index.impl.IndexNodeImpl;

public class IndexFiller {
	private int myPreorderCounter = 0;

	private int myPostorderCounter = 0;

	private Stack<IndexNode> myStack;

	private Index myIndex;

	public IndexFiller(Index index) {
		myIndex = index;
		myStack = new Stack<IndexNode>();
		myStack.push(new IndexNodeImpl(-1, 0, 0, false, "", ""));
	}
	
	public void startElement(String name, String value, boolean isAttribute) {
		IndexNode node = new IndexNodeImpl(myPreorderCounter, 0, myStack.peek()
				.getPreorder(), isAttribute, name, value);
		myStack.push(node);
		myPreorderCounter++;
	}
	
	public void startElement(String name, String value) {
		startElement(name, value, false);
	}
	
	public void endElement() {
		IndexNode node = myStack.pop();
		node.setPostorder(myPostorderCounter);
		myPostorderCounter++;
		myIndex.add(node);
	}
	
	public void appendElementValue(String value) {
		myStack.peek().appendNodeValue(value);
	}
}
