package org.kropp.tests;

import org.kropp.util.*;
import junit.framework.TestCase;

public class BTreeTest extends TestCase {
	public void testPut22() {
		BTree<Integer, String> tree = new BTree<Integer, String>();
		tree.put(1, "Test 1");
		tree.put(0, "Test 0");
		tree.put(5, "Test 5");
		tree.put(4, "Test 4");
		tree.put(2, "Test 2");
		tree.put(3, "Test 3");
		tree.put(9, "Test 9");
		tree.put(8, "Test 8");
		tree.put(7, "Test 7");
		tree.put(6, "Test 6");
		tree.put(11, "Test 1");
		tree.put(10, "Test 0");
		tree.put(15, "Test 5");
		tree.put(14, "Test 4");
		tree.put(12, "Test 2");
		tree.put(13, "Test 3");
		tree.put(19, "Test 9");
		tree.put(18, "Test 8");
		tree.put(21, "Test 21");
		tree.put(20, "Test 20");
		tree.put(17, "Test 7");
		tree.put(16, "Test 6");

		assertEquals(
				"[11]\nChildren: {[3, 7]\nChildren: {[0, 1, 2, 3] [4, 5, 6, 7] [8, 9, 10, 11] } [15, 18]\nChildren: {[12, 13, 14, 15] [16, 17, 18] [19, 20, 21] } }",
				tree.toString());
	}

	public void testGetValue() {
		BTree<Integer, String> tree = new BTree<Integer, String>();
		for (int i = 255; i >= 0; i--) {
			tree.put(i, "Test " + i);
		}
		tree.put(0, "Attention");

		for (int i = 1; i <= 255; i++) {
			assertEquals("Test " + i, tree.getValue(i));
		}
		assertEquals("Attention", tree.getValue(0));
	}
	
	public void testIterator() {
		BTree<Integer, String> tree = new BTree<Integer, String>();
		for (int i = 16; i >= 0; i--) {
			tree.put(i, "Test " + i);
		}
		
		StringBuffer result = new StringBuffer();
		for(String str : tree) {
			result.append(str);
		}
		
		assertEquals("Test 0Test 1Test 2Test 3Test 4Test 5Test 6Test 7Test 8Test 9Test 10Test 11Test 12Test 13Test 14Test 15Test 16", result.toString());
	}
}
