package org.kropp.tests;

import java.util.List;

import org.kropp.index.Index;
import org.kropp.index.impl.SearchEngine;
import org.kropp.util.xml.XMLIndexFactory;
import org.kropp.util.xml.XPathQuery;

import junit.framework.TestCase;

public class SearchEngineTestNasaXml extends TestCase {
	private Index myTestIndex;
	
	public void setUp() {
		myTestIndex = XMLIndexFactory.getInstance().createIndex("nasa.xml");
	}
	
	public void tearDown() {
		myTestIndex.delete();
	}
	
	public void testSearch1() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//dataset/title"));
		
		assertEquals("[Grids of stellar models. III. From 0.8 to 120 Msolar at Z=0.004]", result.toString());
	}
	
	public void testSearch2() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//dataset/title/following-sibling::altname/@type"));
		
		assertEquals("[ADC, CDS, brief]", result.toString());
	}
	
	public void testSearch3() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//dataset/references/child::reference/journal/preceding-sibling::author/lastName"));
		
		assertEquals("[Charbonnel, Meynet, Maeder, Schaller, Schaerer]", result.toString());
	}
	
	public void testSearch4() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//dataset/references/@type"));
		
		assertEquals("[source]", result.toString());
	}
}
