package org.kropp.tests;

import java.util.*;

import org.kropp.index.Index;
import org.kropp.index.impl.SearchEngine;
import org.kropp.util.xml.*;

import junit.framework.TestCase;

public class SearchEngineTestTestXml extends TestCase {
	private Index myTestIndex;
	
	public void setUp() {
		myTestIndex = XMLIndexFactory.getInstance().createIndex("test.xml");
	}
	
	public void tearDown() {
		myTestIndex.delete();
	}

	public void testSearch1() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/target/javac"));
		
		assertEquals("[, ]", result.toString());
	}

	public void testSearch2() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/@name"));
		
		assertEquals("[javaadv6]", result.toString());
	}

	public void testSearch3() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/target/@name"));
		
		assertEquals("[init, api-compile, api-deploy, impl-compile, all, run]", result.toString());
	}

	public void testSearch4() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/property/preceding-sibling::description"));
		
		assertEquals("[Java Advanced Homework 6]", result.toString());
	}

	public void testSearch5() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/following-sibling::tstamp"));
		
		assertEquals("[]", result.toString());
	}
	
	public void testSearch6() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/description"));
		
		assertEquals("[Java Advanced Homework 6]", result.toString());
	}
	
	public void testSearch7() {
		List<String> result = SearchEngine.search(myTestIndex, new XPathQuery("//project/*/preceding-sibling::description"));
		
		assertEquals("[Java Advanced Homework 6]", result.toString());
	}
}
