package org.kropp.tests;

import java.util.*;

import junit.framework.TestCase;

public class StackTest extends TestCase {
	private Stack<String> myStack = new Stack<String>();

	public void testPushAndPop() {
		myStack.clear();
		myStack.push("Test1");
		assertFalse(myStack.isEmpty());
		myStack.push("Test2");
		String test = myStack.pop();
		assertEquals(test, "Test2");
		test = myStack.pop();
		assertEquals(test, "Test1");
		try {
			myStack.pop();
			throw new RuntimeException(
					"pop() didn't throw an exception when called on empty stack");
		} catch (EmptyStackException e) {
			// That's OK
		}
	}

	public void testTop() {
		myStack.clear();
		myStack.push("Test First");
		myStack.push("Test Top");
		String test = myStack.peek();
		assertEquals(test, "Test Top");
		myStack.pop();
		// "Test first" is still in the stack
		assertFalse(myStack.isEmpty());
	}

	public void testIsEmpty() {
		myStack.clear();
		assertTrue(myStack.isEmpty());
		myStack.push("Test");
		assertFalse(myStack.isEmpty());
		myStack.pop();
		assertTrue(myStack.isEmpty());
	}

	public void testClear() {
		for (int i = 0; i < 5; i++) {
			myStack.push("test" + i);
		}
		assertFalse(myStack.isEmpty());
		myStack.clear();
		assertTrue(myStack.isEmpty());
	}
}
