package org.kropp.util;

import junit.framework.TestCase;

public class BTreeNodeTest extends TestCase {
	public void testPut1() {
		BTreeNode<Integer, String> root = new BTreeNode<Integer, String>(4,
				null);
		root.put(1, "Test 1");

		assertEquals("[1]\nChildren: {[1] }", root.toString());
	}

	public void testPut4() {
		BTreeNode<Integer, String> root = new BTreeNode<Integer, String>(4,
				null);
		root.put(1, "Test 1");
		root.put(0, "Test 0");
		root.put(3, "Test 3");
		root.put(2, "Test 2");

		assertEquals("[3]\nChildren: {[0, 1, 2, 3] }", root.toString());
	}

	public void testPut6() {
		BTreeNode<Integer, String> root = new BTreeNode<Integer, String>(4,
				null);
		root.put(1, "Test 1");
		root.put(0, "Test 0");
		root.put(5, "Test 5");
		root.put(4, "Test 4");
		root.put(2, "Test 2");
		root.put(3, "Test 3");

		assertEquals("[1, 5]\nChildren: {[0, 1] [2, 3, 4, 5] }", root
				.toString());
	}

	public void testPut10() {
		BTreeNode<Integer, String> root = new BTreeNode<Integer, String>(4,
				null);
		root.put(1, "Test 1");
		root.put(0, "Test 0");
		root.put(5, "Test 5");
		root.put(4, "Test 4");
		root.put(2, "Test 2");
		root.put(3, "Test 3");
		root.put(9, "Test 9");
		root.put(8, "Test 8");
		root.put(7, "Test 7");
		root.put(6, "Test 6");

		assertEquals(
				"[3, 5, 9]\nChildren: {[0, 1, 2, 3] [4, 5] [6, 7, 8, 9] }",
				root.toString());
	}
}
